Validation
The DevExtreme JavaScript Gantt component allows you to validate relationships between tasks and handle errors. Set the enableDependencyValidation property to true to enable task validation.
The Gantt supports the following dependency validation rules:
- Finish to Start (FS) - A successor task's start point should be equal or later than the preceding task's end point.
- Start to Start (SS) - A successor task's start point should be equal or later than the preceding task's start point.
- Finish to Finish (FF) - A successor task's end point should be equal or later than the preceding task's end point.
- Start to Finish (SF) - A successor task's end point should be equal or later than a preceding task's start point.
The Gantt also has the autoUpdateParentTasks property that enables validation for parent-child relationship:
- A parent task's duration equals a summary duration of its child tasks.
- A parent task and its first child starts at the same time.
- A parent task and its last child ends at the same time.
- A parent task's progress is a summary progress of its child tasks.
The Gantt processes changes in task values before they are saved to a database. The component displays a popup window with a list of available actions if an error can be handled in several ways.
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
$(() => {
const gantt = $('#gantt').dxGantt({
validation: {
autoUpdateParentTasks: true,
validateDependencies: true,
enablePredecessorGap: true,
},
tasks: {
dataSource: tasks,
},
dependencies: {
dataSource: dependencies,
},
editing: {
enabled: true,
},
columns: [{
dataField: 'title',
caption: 'Task',
width: 300,
}, {
dataField: 'start',
caption: 'Start Date',
}, {
dataField: 'end',
caption: 'End Date',
}],
taskListWidth: 500,
taskTitlePosition: 'none',
}).dxGantt('instance');
$('#autoUpdateParentTasks').dxCheckBox({
text: 'Auto Update Parent Tasks',
value: true,
onValueChanged(e) {
gantt.option('validation.autoUpdateParentTasks', e.value);
},
});
$('#validateDependencies').dxCheckBox({
text: 'Enable Dependency Validation',
value: true,
onValueChanged(e) {
gantt.option('validation.validateDependencies', e.value);
},
});
$('#enablePredecessorGap').dxCheckBox({
text: 'Enable Predecessor Gap',
value: true,
onValueChanged(e) {
gantt.option('validation.enablePredecessorGap', e.value);
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<script src="https://cdn3.devexpress.com/jslib/23.1.6/js/dx-gantt.min.js"></script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.6/css/dx.light.css" />
<link rel="stylesheet" href="https://cdn3.devexpress.com/jslib/23.1.6/css/dx-gantt.min.css" />
<script src="https://cdn3.devexpress.com/jslib/23.1.6/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="options">
<div class="caption">Options</div>
<div class="option">
<div id="autoUpdateParentTasks"></div>
</div>
<div class="option">
<div id="validateDependencies"></div>
</div>
<div class="option">
<div id="enablePredecessorGap"></div>
</div>
</div>
<div id="gantt"> </div>
</div>
</body>
</html>
#gantt {
height: 700px;
}
.options {
margin-bottom: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
margin-right: 40px;
display: inline-block;
}
.option:last-child {
margin-right: 0;
}
const currentDate = new Date(Date.now());
const month = currentDate.getMonth();
const year = currentDate.getFullYear();
const tasks = [{
id: 1,
parentId: 0,
title: 'Johnson Residence Construction Project',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 2,
parentId: 1,
title: 'Planning and Pre-Construction Phase',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 3,
parentId: 2,
title: 'Architectural Design and Site Planning',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 4,
parentId: 2,
title: 'Engineering and Final Blueprint',
start: new Date(year, month - 1, 8),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 5,
parentId: 2,
title: 'City Permits and Contracts',
start: new Date(year, month - 1, 15),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 6,
parentId: 1,
title: 'Construction Phase',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 7,
parentId: 6,
title: 'Grading and Excavation',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 22),
progress: 0,
}, {
id: 8,
parentId: 6,
title: 'Demolition and Removal',
start: new Date(year, month - 1, 19),
end: new Date(year, month - 1, 23),
progress: 0,
}, {
id: 9,
parentId: 6,
title: 'Foundation and Concrete ',
start: new Date(year, month - 1, 22),
end: new Date(year, month - 1, 28),
progress: 0,
}, {
id: 10,
parentId: 6,
title: 'Rough Framing and Carpentery',
start: new Date(year, month - 1, 25),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 11,
parentId: 6,
title: 'Inspection (Structure)',
start: new Date(year, month, 5),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 12,
parentId: 6,
title: 'Electrical Rough-in',
start: new Date(year, month, 6),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 13,
parentId: 6,
title: 'Plumbing Rough-in',
start: new Date(year, month, 19),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 14,
parentId: 6,
title: 'Heating and A/C',
start: new Date(year, month, 19),
end: new Date(year, month, 26),
progress: 0,
}, {
id: 15,
parentId: 6,
title: 'Drywall',
start: new Date(year, month, 25),
end: new Date(year, month + 1, 10),
progress: 0,
}, {
id: 16,
parentId: 6,
title: 'Painting (Exterior)',
start: new Date(year, month + 1, 7),
end: new Date(year, month + 1, 21),
progress: 0,
}, {
id: 17,
parentId: 6,
title: 'Interior Carpentery (Interior)',
start: new Date(year, month + 1, 17),
end: new Date(year, month + 1, 28),
progress: 0,
}, {
id: 18,
parentId: 6,
title: 'Flooring and Interior Paint',
start: new Date(year, month + 1, 26),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 19,
parentId: 1,
title: 'Final Phase',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 20,
parentId: 19,
title: 'Review-Punch List',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 23),
progress: 0,
}, {
id: 21,
parentId: 19,
title: 'Final Inspection',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 24),
progress: 0,
}, {
id: 22,
parentId: 19,
title: 'Final Paperwork and Documents',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 28),
progress: 0,
}];
const dependencies = [{
id: 1,
predecessorId: 4,
successorId: 5,
type: 0,
}, {
id: 2,
predecessorId: 5,
successorId: 7,
type: 0,
}, {
id: 3,
predecessorId: 12,
successorId: 13,
type: 0,
}, {
id: 4,
predecessorId: 13,
successorId: 14,
type: 0,
}, {
id: 5,
predecessorId: 18,
successorId: 20,
type: 0,
}, {
id: 6,
predecessorId: 21,
successorId: 22,
type: 0,
}];

Validation
The DevExtreme JavaScript Gantt component allows you to validate relationships between tasks and handle errors. Set the enableDependencyValidation property to true to enable task validation.
The Gantt supports the following dependency validation rules:
- Finish to Start (FS) - A successor task's start point should be equal or later than the preceding task's end point.
- Start to Start (SS) - A successor task's start point should be equal or later than the preceding task's start point.
- Finish to Finish (FF) - A successor task's end point should be equal or later than the preceding task's end point.
- Start to Finish (SF) - A successor task's end point should be equal or later than a preceding task's start point.
The Gantt also has the autoUpdateParentTasks property that enables validation for parent-child relationship:
- A parent task's duration equals a summary duration of its child tasks.
- A parent task and its first child starts at the same time.
- A parent task and its last child ends at the same time.
- A parent task's progress is a summary progress of its child tasks.
The Gantt processes changes in task values before they are saved to a database. The component displays a popup window with a list of available actions if an error can be handled in several ways.
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
import React from 'react';
import Gantt, {
Tasks, Dependencies, Column, Validation, Editing,
} from 'devextreme-react/gantt';
import CheckBox from 'devextreme-react/check-box';
import { tasks, dependencies } from './data.js';
function App() {
const [ganttConfig, setGanttConfig] = React.useState({
autoUpdateParentTasks: true,
validateDependencies: true,
enablePredecessorGap: true,
});
return (
<div id="form-demo">
<div className="options">
<div className="caption">Options</div>
<div className="option">
<CheckBox
text="Auto Update Parent Tasks"
value={ganttConfig.autoUpdateParentTasks}
onValueChanged={onAutoUpdateParentTasksChanged}
/>
</div>
{' '}
<div className="option">
<CheckBox
text="Enable Dependency Validation"
value={ganttConfig.validateDependencies}
onValueChanged={onValidateDependenciesChanged}
/>
</div>
{' '}
<div className="option">
<CheckBox
text="Enable Predecessor Gap"
value={ganttConfig.enablePredecessorGap}
onValueChanged={onEnablePredecessorGapChanged}
/>
</div>
</div>
<div className="widget-container">
<Gantt
taskListWidth={500}
height={700}
taskTitlePosition="none">
<Validation
autoUpdateParentTasks={ganttConfig.autoUpdateParentTasks}
validateDependencies={ganttConfig.validateDependencies}
enablePredecessorGap={ganttConfig.enablePredecessorGap} />
<Tasks dataSource={tasks} />
<Dependencies dataSource={dependencies} />
<Column dataField="title" caption="Task" width={300} />
<Column dataField="start" caption="Start Date" />
<Column dataField="end" caption="End Date" />
<Editing enabled />
</Gantt>
</div>
</div>
);
function onAutoUpdateParentTasksChanged(e) {
setGanttConfig({
...ganttConfig,
autoUpdateParentTasks: e.value,
});
}
function onValidateDependenciesChanged(e) {
setGanttConfig({
...ganttConfig,
validateDependencies: e.value,
});
}
function onEnablePredecessorGapChanged(e) {
setGanttConfig({
...ganttConfig,
enablePredecessorGap: e.value,
});
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx-gantt.min.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#gantt {
height: 700px;
}
.options {
margin-bottom: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
margin-right: 40px;
display: inline-block;
}
.option:last-child {
margin-right: 0;
}
export const currentDate = new Date(Date.now());
const month = currentDate.getMonth();
const year = currentDate.getFullYear();
export const tasks = [{
id: 1,
parentId: 0,
title: 'Johnson Residence Construction Project',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 2,
parentId: 1,
title: 'Planning and Pre-Construction Phase',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 3,
parentId: 2,
title: 'Architectural Design and Site Planning',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 4,
parentId: 2,
title: 'Engineering and Final Blueprint',
start: new Date(year, month - 1, 8),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 5,
parentId: 2,
title: 'City Permits and Contracts',
start: new Date(year, month - 1, 15),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 6,
parentId: 1,
title: 'Construction Phase',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 7,
parentId: 6,
title: 'Grading and Excavation',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 22),
progress: 0,
}, {
id: 8,
parentId: 6,
title: 'Demolition and Removal',
start: new Date(year, month - 1, 19),
end: new Date(year, month - 1, 23),
progress: 0,
}, {
id: 9,
parentId: 6,
title: 'Foundation and Concrete ',
start: new Date(year, month - 1, 22),
end: new Date(year, month - 1, 28),
progress: 0,
}, {
id: 10,
parentId: 6,
title: 'Rough Framing and Carpentery',
start: new Date(year, month - 1, 25),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 11,
parentId: 6,
title: 'Inspection (Structure)',
start: new Date(year, month, 5),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 12,
parentId: 6,
title: 'Electrical Rough-in',
start: new Date(year, month, 6),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 13,
parentId: 6,
title: 'Plumbing Rough-in',
start: new Date(year, month, 19),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 14,
parentId: 6,
title: 'Heating and A/C',
start: new Date(year, month, 19),
end: new Date(year, month, 26),
progress: 0,
}, {
id: 15,
parentId: 6,
title: 'Drywall',
start: new Date(year, month, 25),
end: new Date(year, month + 1, 10),
progress: 0,
}, {
id: 16,
parentId: 6,
title: 'Painting (Exterior)',
start: new Date(year, month + 1, 7),
end: new Date(year, month + 1, 21),
progress: 0,
}, {
id: 17,
parentId: 6,
title: 'Interior Carpentery (Interior)',
start: new Date(year, month + 1, 17),
end: new Date(year, month + 1, 28),
progress: 0,
}, {
id: 18,
parentId: 6,
title: 'Flooring and Interior Paint',
start: new Date(year, month + 1, 26),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 19,
parentId: 1,
title: 'Final Phase',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 20,
parentId: 19,
title: 'Review-Punch List',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 23),
progress: 0,
}, {
id: 21,
parentId: 19,
title: 'Final Inspection',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 24),
progress: 0,
}, {
id: 22,
parentId: 19,
title: 'Final Paperwork and Documents',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 28),
progress: 0,
}];
export const dependencies = [{
id: 1,
predecessorId: 4,
successorId: 5,
type: 0,
}, {
id: 2,
predecessorId: 5,
successorId: 7,
type: 0,
}, {
id: 3,
predecessorId: 12,
successorId: 13,
type: 0,
}, {
id: 4,
predecessorId: 13,
successorId: 14,
type: 0,
}, {
id: 5,
predecessorId: 18,
successorId: 20,
type: 0,
}, {
id: 6,
predecessorId: 21,
successorId: 22,
type: 0,
}];
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
defaultExtension: 'js',
map: {
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.8.1/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.6/cjs',
'devextreme-react': 'npm:devextreme-react@23.1.6',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.2/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.49/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);

Backend API
<template>
<div id="form-demo">
<div class="options">
<div class="caption">Options</div>
<div class="option">
<DxCheckBox
v-model:value="autoUpdateParentTasks"
text="Auto Update Parent Tasks"
/>
</div>
<div class="option">
<DxCheckBox
v-model:value="validateDependencies"
text="Enable Dependency Validation"
/>
</div>
<div class="option">
<DxCheckBox
v-model:value="enablePredecessorGap"
text="Enable Predecessor Gap"
/>
</div>
</div>
<div class="widget-container">
<DxGantt
:task-list-width="500"
:height="700"
task-title-position="none"
>
<DxValidation
:auto-update-parent-tasks="autoUpdateParentTasks"
:validate-dependencies="validateDependencies"
:enable-predecessor-gap="enablePredecessorGap"
/>
<DxTasks :data-source="tasks"/>
<DxDependencies :data-source="dependencies"/>
<DxEditing :enabled="true"/>
<DxColumn
:width="300"
data-field="title"
caption="Task"
/>
<DxColumn
data-field="start"
caption="Start Date"
/>
<DxColumn
data-field="end"
caption="End Date"
/>
</DxGantt>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import {
DxGantt,
DxTasks,
DxDependencies,
DxColumn,
DxEditing,
DxValidation,
} from 'devextreme-vue/gantt';
import DxCheckBox from 'devextreme-vue/check-box';
import {
tasks,
dependencies,
} from './data.ts';
const autoUpdateParentTasks = ref(true);
const validateDependencies = ref(true);
const enablePredecessorGap = ref(true);
</script>
<style>
.options {
margin-bottom: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
margin-right: 44px;
display: inline-block;
}
.option:last-child {
margin-right: 0;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
const currentDate = new Date(Date.now());
const month = currentDate.getMonth();
const year = currentDate.getFullYear();
export const tasks = [{
id: 1,
parentId: 0,
title: 'Johnson Residence Construction Project',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 2,
parentId: 1,
title: 'Planning and Pre-Construction Phase',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 3,
parentId: 2,
title: 'Architectural Design and Site Planning',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 4,
parentId: 2,
title: 'Engineering and Final Blueprint',
start: new Date(year, month - 1, 8),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 5,
parentId: 2,
title: 'City Permits and Contracts',
start: new Date(year, month - 1, 15),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 6,
parentId: 1,
title: 'Construction Phase',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 7,
parentId: 6,
title: 'Grading and Excavation',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 22),
progress: 0,
}, {
id: 8,
parentId: 6,
title: 'Demolition and Removal',
start: new Date(year, month - 1, 19),
end: new Date(year, month - 1, 23),
progress: 0,
}, {
id: 9,
parentId: 6,
title: 'Foundation and Concrete ',
start: new Date(year, month - 1, 22),
end: new Date(year, month - 1, 28),
progress: 0,
}, {
id: 10,
parentId: 6,
title: 'Rough Framing and Carpentery',
start: new Date(year, month - 1, 25),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 11,
parentId: 6,
title: 'Inspection (Structure)',
start: new Date(year, month, 5),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 12,
parentId: 6,
title: 'Electrical Rough-in',
start: new Date(year, month, 6),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 13,
parentId: 6,
title: 'Plumbing Rough-in',
start: new Date(year, month, 19),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 14,
parentId: 6,
title: 'Heating and A/C',
start: new Date(year, month, 19),
end: new Date(year, month, 26),
progress: 0,
}, {
id: 15,
parentId: 6,
title: 'Drywall',
start: new Date(year, month, 25),
end: new Date(year, month + 1, 10),
progress: 0,
}, {
id: 16,
parentId: 6,
title: 'Painting (Exterior)',
start: new Date(year, month + 1, 7),
end: new Date(year, month + 1, 21),
progress: 0,
}, {
id: 17,
parentId: 6,
title: 'Interior Carpentery (Interior)',
start: new Date(year, month + 1, 17),
end: new Date(year, month + 1, 28),
progress: 0,
}, {
id: 18,
parentId: 6,
title: 'Flooring and Interior Paint',
start: new Date(year, month + 1, 26),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 19,
parentId: 1,
title: 'Final Phase',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 20,
parentId: 19,
title: 'Review-Punch List',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 23),
progress: 0,
}, {
id: 21,
parentId: 19,
title: 'Final Inspection',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 24),
progress: 0,
}, {
id: 22,
parentId: 19,
title: 'Final Paperwork and Documents',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 28),
progress: 0,
}];
export const dependencies = [{
id: 1,
predecessorId: 4,
successorId: 5,
type: 0,
}, {
id: 2,
predecessorId: 5,
successorId: 7,
type: 0,
}, {
id: 3,
predecessorId: 12,
successorId: 13,
type: 0,
}, {
id: 4,
predecessorId: 13,
successorId: 14,
type: 0,
}, {
id: 5,
predecessorId: 18,
successorId: 20,
type: 0,
}, {
id: 6,
predecessorId: 21,
successorId: 22,
type: 0,
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx-gantt.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
The Gantt supports the following dependency validation rules:
- Finish to Start (FS) - A successor task's start point should be equal or later than the preceding task's end point.
- Start to Start (SS) - A successor task's start point should be equal or later than the preceding task's start point.
- Finish to Finish (FF) - A successor task's end point should be equal or later than the preceding task's end point.
- Start to Finish (SF) - A successor task's end point should be equal or later than a preceding task's start point.
The Gantt also has the autoUpdateParentTasks property that enables validation for parent-child relationship:
- A parent task's duration equals a summary duration of its child tasks.
- A parent task and its first child starts at the same time.
- A parent task and its last child ends at the same time.
- A parent task's progress is a summary progress of its child tasks.
The Gantt processes changes in task values before they are saved to a database. The component displays a popup window with a list of available actions if an error can be handled in several ways.

Validation
The DevExtreme JavaScript Gantt component allows you to validate relationships between tasks and handle errors. Set the enableDependencyValidation property to true to enable task validation.
The Gantt supports the following dependency validation rules:
- Finish to Start (FS) - A successor task's start point should be equal or later than the preceding task's end point.
- Start to Start (SS) - A successor task's start point should be equal or later than the preceding task's start point.
- Finish to Finish (FF) - A successor task's end point should be equal or later than the preceding task's end point.
- Start to Finish (SF) - A successor task's end point should be equal or later than a preceding task's start point.
The Gantt also has the autoUpdateParentTasks property that enables validation for parent-child relationship:
- A parent task's duration equals a summary duration of its child tasks.
- A parent task and its first child starts at the same time.
- A parent task and its last child ends at the same time.
- A parent task's progress is a summary progress of its child tasks.
The Gantt processes changes in task values before they are saved to a database. The component displays a popup window with a list of available actions if an error can be handled in several ways.
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
<div id="demo-container">
<div class="options">
<div class="caption">Options</div>
<div class="option">
<dx-check-box
text="Auto Update Parent Tasks"
[(value)]="autoUpdateParentTasks"
></dx-check-box>
</div>
<div class="option">
<dx-check-box
text="Enable Dependency Validation"
[(value)]="validateDependencies"
></dx-check-box>
</div>
<div class="option">
<dx-check-box
text="Enable Predecessor Gap"
[(value)]="enablePredecessorGap"
></dx-check-box>
</div>
</div>
<div class="widget-container">
<dx-gantt taskListWidth="500" height="700" taskTitlePosition="none">
<dxo-validation
[autoUpdateParentTasks]="autoUpdateParentTasks"
[validateDependencies]="validateDependencies"
[enablePredecessorGap]="enablePredecessorGap"
></dxo-validation>
<dxo-tasks [dataSource]="tasks"></dxo-tasks>
<dxo-dependencies [dataSource]="dependencies"></dxo-dependencies>
<dxi-column dataField="title" caption="Task" [width]="300"></dxi-column>
<dxi-column
dataField="start"
caption="Start Date"
dataType="date"
></dxi-column>
<dxi-column
dataField="end"
caption="End Date"
dataType="date"
></dxi-column>
<dxo-editing [enabled]="true"></dxo-editing>
</dx-gantt>
</div>
</div>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule, BrowserTransferStateModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxGanttModule, DxCheckBoxModule } from 'devextreme-angular';
import { Service, Task, Dependency } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service],
preserveWhitespaces: true,
})
export class AppComponent {
tasks: Task[];
dependencies: Dependency[];
autoUpdateParentTasks: boolean;
validateDependencies: boolean;
enablePredecessorGap: boolean;
constructor(service: Service) {
this.tasks = service.getTasks();
this.dependencies = service.getDependencies();
this.autoUpdateParentTasks = true;
this.validateDependencies = true;
this.enablePredecessorGap = true;
}
}
@NgModule({
imports: [
BrowserModule,
BrowserTransferStateModule,
DxGanttModule,
DxCheckBoxModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
#gantt {
height: 700px;
}
.options {
margin-bottom: 20px;
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
position: relative;
}
.caption {
font-size: 18px;
font-weight: 500;
}
.option {
margin-top: 10px;
margin-right: 40px;
display: inline-block;
}
.option:last-child {
margin-right: 0;
}
import { Injectable } from '@angular/core';
export class Task {
id: number;
parentId: number;
title: string;
start: Date;
end: Date;
progress: number;
}
export class Dependency {
id: number;
predecessorId: number;
successorId: number;
type: number;
}
const currentDate: Date = new Date(Date.now());
const month: number = currentDate.getMonth();
const year: number = currentDate.getFullYear();
const tasks: Task[] = [{
id: 1,
parentId: 0,
title: 'Johnson Residence Construction Project',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 2,
parentId: 1,
title: 'Planning and Pre-Construction Phase',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 1),
progress: 0,
}, {
id: 3,
parentId: 2,
title: 'Architectural Design and Site Planning',
start: new Date(year, month - 1, 1),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 4,
parentId: 2,
title: 'Engineering and Final Blueprint',
start: new Date(year, month - 1, 8),
end: new Date(year, month - 1, 15),
progress: 0,
}, {
id: 5,
parentId: 2,
title: 'City Permits and Contracts',
start: new Date(year, month - 1, 15),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 6,
parentId: 1,
title: 'Construction Phase',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 18),
progress: 0,
}, {
id: 7,
parentId: 6,
title: 'Grading and Excavation',
start: new Date(year, month - 1, 18),
end: new Date(year, month - 1, 22),
progress: 0,
}, {
id: 8,
parentId: 6,
title: 'Demolition and Removal',
start: new Date(year, month - 1, 19),
end: new Date(year, month - 1, 23),
progress: 0,
}, {
id: 9,
parentId: 6,
title: 'Foundation and Concrete ',
start: new Date(year, month - 1, 22),
end: new Date(year, month - 1, 28),
progress: 0,
}, {
id: 10,
parentId: 6,
title: 'Rough Framing and Carpentery',
start: new Date(year, month - 1, 25),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 11,
parentId: 6,
title: 'Inspection (Structure)',
start: new Date(year, month, 5),
end: new Date(year, month, 5),
progress: 0,
}, {
id: 12,
parentId: 6,
title: 'Electrical Rough-in',
start: new Date(year, month, 6),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 13,
parentId: 6,
title: 'Plumbing Rough-in',
start: new Date(year, month, 19),
end: new Date(year, month, 19),
progress: 0,
}, {
id: 14,
parentId: 6,
title: 'Heating and A/C',
start: new Date(year, month, 19),
end: new Date(year, month, 26),
progress: 0,
}, {
id: 15,
parentId: 6,
title: 'Drywall',
start: new Date(year, month, 25),
end: new Date(year, month + 1, 10),
progress: 0,
}, {
id: 16,
parentId: 6,
title: 'Painting (Exterior)',
start: new Date(year, month + 1, 7),
end: new Date(year, month + 1, 21),
progress: 0,
}, {
id: 17,
parentId: 6,
title: 'Interior Carpentery (Interior)',
start: new Date(year, month + 1, 17),
end: new Date(year, month + 1, 28),
progress: 0,
}, {
id: 18,
parentId: 6,
title: 'Flooring and Interior Paint',
start: new Date(year, month + 1, 26),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 19,
parentId: 1,
title: 'Final Phase',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 9),
progress: 0,
}, {
id: 20,
parentId: 19,
title: 'Review-Punch List',
start: new Date(year, month + 2, 9),
end: new Date(year, month + 2, 23),
progress: 0,
}, {
id: 21,
parentId: 19,
title: 'Final Inspection',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 24),
progress: 0,
}, {
id: 22,
parentId: 19,
title: 'Final Paperwork and Documents',
start: new Date(year, month + 2, 24),
end: new Date(year, month + 2, 28),
progress: 0,
}];
const dependencies: Dependency[] = [{
id: 1,
predecessorId: 4,
successorId: 5,
type: 0,
}, {
id: 2,
predecessorId: 5,
successorId: 7,
type: 0,
}, {
id: 3,
predecessorId: 12,
successorId: 13,
type: 0,
}, {
id: 4,
predecessorId: 13,
successorId: 14,
type: 0,
}, {
id: 5,
predecessorId: 18,
successorId: 20,
type: 0,
}, {
id: 6,
predecessorId: 21,
successorId: 22,
type: 0,
}];
@Injectable()
export class Service {
getTasks(): Task[] {
return tasks;
}
getDependencies(): Dependency[] {
return dependencies;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.17',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.17',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.17',
'@angular/forms': 'npm:@angular/forms@12.2.17',
'@angular/common': 'npm:@angular/common@12.2.17',
'@angular/compiler': 'npm:@angular/compiler@12.2.17',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.1/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@23.1.6/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@23.1.6/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.6.2/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.2',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.49',
'devextreme-angular': 'npm:devextreme-angular@23.1.6',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.4/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.4/parser-html.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.17/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@23.1.6/*/package.json',
'npm:devextreme-angular@23.1.6/ui/*/package.json',
'npm:devextreme-angular@23.1.6/package.json',
'npm:devexpress-diagram@2.2.2/package.json',
'npm:devexpress-gantt@4.1.49/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.5/css/dx-gantt.css" />
<script src="https://unpkg.com/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.12.0/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>